// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

//
// This file was autogenerated by a tool.
// Do not modify it.
//

namespace Microsoft.Azure.Batch
{
    using Models = Microsoft.Azure.Batch.Protocol.Models;
    using System;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// A node agent SKU supported by the Batch service. The Batch node agent is a program that runs on each node in the 
    /// pool, and provides the command-and-control interface between the node and the Batch service. There are different 
    /// implementations of the node agent, known as SKUs, for different operating systems.
    /// </summary>
    public partial class NodeAgentSku : IPropertyMetadata
    {
        private readonly string id;
        private readonly Common.OSType? osType;
        private readonly IReadOnlyList<ImageReference> verifiedImageReferences;

        #region Constructors

        internal NodeAgentSku(Models.NodeAgentSku protocolObject)
        {
            this.id = protocolObject.Id;
            this.osType = UtilitiesInternal.MapNullableEnum<Models.OSType, Common.OSType>(protocolObject.OsType);
            this.verifiedImageReferences = ImageReference.ConvertFromProtocolCollectionReadOnly(protocolObject.VerifiedImageReferences);
        }

        #endregion Constructors

        #region NodeAgentSku

        /// <summary>
        /// Gets the id of the node agent SKU.
        /// </summary>
        public string Id
        {
            get { return this.id; }
        }

        /// <summary>
        /// Gets the type of operating system compatible with the node agent SKU.
        /// </summary>
        public Common.OSType? OSType
        {
            get { return this.osType; }
        }

        /// <summary>
        /// Gets the list of images verified to be compatible with this node agent SKU. This collection is not exhaustive 
        /// (the node agent may be compatible with other images).
        /// </summary>
        public IReadOnlyList<ImageReference> VerifiedImageReferences
        {
            get { return this.verifiedImageReferences; }
        }

        #endregion // NodeAgentSku

        #region IPropertyMetadata

        bool IModifiable.HasBeenModified
        {
            //This class is compile time readonly so it cannot have been modified
            get { return false; }
        }

        bool IReadOnly.IsReadOnly
        {
            get { return true; }
            set
            {
                // This class is compile time readonly already
            }
        }

        #endregion // IPropertyMetadata
    }
}