// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Batch.Protocol.Models
{
    using System.Linq;

    /// <summary>
    /// Parameters for a CloudPoolOperations.UpgradeOS request.
    /// </summary>
    public partial class PoolUpgradeOSParameter
    {
        /// <summary>
        /// Initializes a new instance of the PoolUpgradeOSParameter class.
        /// </summary>
        public PoolUpgradeOSParameter() { }

        /// <summary>
        /// Initializes a new instance of the PoolUpgradeOSParameter class.
        /// </summary>
        /// <param name="targetOSVersion">The Azure Guest OS version to be
        /// installed on the virtual machines in the pool.</param>
        public PoolUpgradeOSParameter(string targetOSVersion)
        {
            TargetOSVersion = targetOSVersion;
        }

        /// <summary>
        /// Gets or sets the Azure Guest OS version to be installed on the
        /// virtual machines in the pool.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "targetOSVersion")]
        public string TargetOSVersion { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (TargetOSVersion == null)
            {
                throw new Microsoft.Rest.ValidationException(Microsoft.Rest.ValidationRules.CannotBeNull, "TargetOSVersion");
            }
        }
    }
}
