// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.KeyVault.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// The key restore parameters
    /// </summary>
    public partial class KeyRestoreParameters
    {
        /// <summary>
        /// Initializes a new instance of the KeyRestoreParameters class.
        /// </summary>
        public KeyRestoreParameters() { }

        /// <summary>
        /// Initializes a new instance of the KeyRestoreParameters class.
        /// </summary>
        /// <param name="keyBundleBackup">the backup blob associated with a
        /// key bundle</param>
        public KeyRestoreParameters(byte[] keyBundleBackup)
        {
            KeyBundleBackup = keyBundleBackup;
        }

        /// <summary>
        /// Gets or sets the backup blob associated with a key bundle
        /// </summary>
        [JsonConverter(typeof(Base64UrlJsonConverter))]
        [JsonProperty(PropertyName = "value")]
        public byte[] KeyBundleBackup { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (KeyBundleBackup == null)
            {
                throw new ValidationException(ValidationRules.CannotBeNull, "KeyBundleBackup");
            }
        }
    }
}
