// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Cdn.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Output of custom domain validation.
    /// </summary>
    public partial class ValidateCustomDomainOutput
    {
        /// <summary>
        /// Initializes a new instance of the ValidateCustomDomainOutput class.
        /// </summary>
        public ValidateCustomDomainOutput() { }

        /// <summary>
        /// Initializes a new instance of the ValidateCustomDomainOutput class.
        /// </summary>
        public ValidateCustomDomainOutput(bool? customDomainValidated = default(bool?), string reason = default(string), string message = default(string))
        {
            CustomDomainValidated = customDomainValidated;
            Reason = reason;
            Message = message;
        }

        /// <summary>
        /// Indicates whether the custom domain is validated or not.
        /// </summary>
        [JsonProperty(PropertyName = "customDomainValidated")]
        public bool? CustomDomainValidated { get; set; }

        /// <summary>
        /// The reason why the custom domain is not valid.
        /// </summary>
        [JsonProperty(PropertyName = "reason")]
        public string Reason { get; set; }

        /// <summary>
        /// The message describing why the custom domain is not valid.
        /// </summary>
        [JsonProperty(PropertyName = "message")]
        public string Message { get; set; }

    }
}
