// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.DataLake.Store.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    public partial class EncryptionConfig
    {
        /// <summary>
        /// Initializes a new instance of the EncryptionConfig class.
        /// </summary>
        public EncryptionConfig() { }

        /// <summary>
        /// Initializes a new instance of the EncryptionConfig class.
        /// </summary>
        /// <param name="type">The type of encryption configuration being
        /// used. Currently the only supported types are 'UserManaged' and
        /// 'ServiceManaged'. Possible values include: 'UserManaged',
        /// 'ServiceManaged'</param>
        /// <param name="keyVaultMetaInfo">The Key vault information for
        /// connecting to user managed encryption keys.</param>
        public EncryptionConfig(EncryptionConfigType? type = default(EncryptionConfigType?), KeyVaultMetaInfo keyVaultMetaInfo = default(KeyVaultMetaInfo))
        {
            Type = type;
            KeyVaultMetaInfo = keyVaultMetaInfo;
        }

        /// <summary>
        /// Gets or sets the type of encryption configuration being used.
        /// Currently the only supported types are 'UserManaged' and
        /// 'ServiceManaged'. Possible values include: 'UserManaged',
        /// 'ServiceManaged'
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public EncryptionConfigType? Type { get; set; }

        /// <summary>
        /// Gets or sets the Key vault information for connecting to user
        /// managed encryption keys.
        /// </summary>
        [JsonProperty(PropertyName = "keyVaultMetaInfo")]
        public KeyVaultMetaInfo KeyVaultMetaInfo { get; set; }

    }
}
