// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.DevTestLabs.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// A cost item.
    /// </summary>
    [JsonTransformation]
    public partial class Cost : IResource
    {
        /// <summary>
        /// Initializes a new instance of the Cost class.
        /// </summary>
        public Cost() { }

        /// <summary>
        /// Initializes a new instance of the Cost class.
        /// </summary>
        public Cost(string currencyCode = default(string), IList<CostPerDayProperties> costs = default(IList<CostPerDayProperties>), IList<ResourceCostProperties> resourceCosts = default(IList<ResourceCostProperties>), string id = default(string), string name = default(string), string type = default(string), string location = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>))
        {
            CurrencyCode = currencyCode;
            Costs = costs;
            ResourceCosts = resourceCosts;
            Id = id;
            Name = name;
            Type = type;
            Location = location;
            Tags = tags;
        }

        /// <summary>
        /// The currency code of the cost.
        /// </summary>
        [JsonProperty(PropertyName = "properties.currencyCode")]
        public string CurrencyCode { get; set; }

        /// <summary>
        /// The lab cost component of the cost data.
        /// </summary>
        [JsonProperty(PropertyName = "properties.costs")]
        public IList<CostPerDayProperties> Costs { get; set; }

        /// <summary>
        /// The resource cost component of the cost data.
        /// </summary>
        [JsonProperty(PropertyName = "properties.resourceCosts")]
        public IList<ResourceCostProperties> ResourceCosts { get; set; }

        /// <summary>
        /// The identifier of the resource.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// The name of the resource.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// The type of the resource.
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public string Type { get; set; }

        /// <summary>
        /// The location of the resource.
        /// </summary>
        [JsonProperty(PropertyName = "location")]
        public string Location { get; set; }

        /// <summary>
        /// The tags of the resource.
        /// </summary>
        [JsonProperty(PropertyName = "tags")]
        public IDictionary<string, string> Tags { get; set; }

    }
}
