// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Graph.RBAC.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Request parameters for GetObjectsByObjectIds API call
    /// </summary>
    public partial class GetObjectsParameters
    {
        /// <summary>
        /// Initializes a new instance of the GetObjectsParameters class.
        /// </summary>
        public GetObjectsParameters() { }

        /// <summary>
        /// Initializes a new instance of the GetObjectsParameters class.
        /// </summary>
        /// <param name="includeDirectoryObjectReferences">If true, also searches for object ids in the partner tenant</param>
        /// <param name="objectIds">Requested object Ids</param>
        /// <param name="types">Requested object types</param>
        public GetObjectsParameters(bool includeDirectoryObjectReferences, IList<string> objectIds = default(IList<string>), IList<string> types = default(IList<string>))
        {
            ObjectIds = objectIds;
            Types = types;
            IncludeDirectoryObjectReferences = includeDirectoryObjectReferences;
        }

        /// <summary>
        /// Gets or sets requested object Ids
        /// </summary>
        [JsonProperty(PropertyName = "objectIds")]
        public IList<string> ObjectIds { get; set; }

        /// <summary>
        /// Gets or sets requested object types
        /// </summary>
        [JsonProperty(PropertyName = "types")]
        public IList<string> Types { get; set; }

        /// <summary>
        /// Gets or sets if true, also searches for object ids in the partner
        /// tenant
        /// </summary>
        [JsonProperty(PropertyName = "includeDirectoryObjectReferences")]
        public bool IncludeDirectoryObjectReferences { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
        }
    }
}
