// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Insights.Models
{
    using System.Linq;

    /// <summary>
    /// Specifies the action to post to service when the rule condition is
    /// evaluated.
    /// </summary>
    [Newtonsoft.Json.JsonObject("Microsoft.Azure.Management.Insights.Models.RuleWebhookAction")]
    public partial class RuleWebhookAction : RuleAction
    {
        /// <summary>
        /// Initializes a new instance of the RuleWebhookAction class.
        /// </summary>
        public RuleWebhookAction() { }

        /// <summary>
        /// Initializes a new instance of the RuleWebhookAction class.
        /// </summary>
        /// <param name="serviceUri">the service uri to Post the
        /// notitication.</param>
        /// <param name="properties">the dictionary of custom properties to
        /// include with the post operation.</param>
        public RuleWebhookAction(string serviceUri = default(string), System.Collections.Generic.IDictionary<string, string> properties = default(System.Collections.Generic.IDictionary<string, string>))
        {
            ServiceUri = serviceUri;
            Properties = properties;
        }

        /// <summary>
        /// Gets or sets the service uri to Post the notitication.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "serviceUri")]
        public string ServiceUri { get; set; }

        /// <summary>
        /// Gets or sets the dictionary of custom properties to include with
        /// the post operation.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties")]
        public System.Collections.Generic.IDictionary<string, string> Properties { get; set; }

    }
}
