// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Insights.Models
{
    using System.Linq;

    /// <summary>
    /// The parameters for the scaling action.
    /// </summary>
    public partial class ScaleAction
    {
        /// <summary>
        /// Initializes a new instance of the ScaleAction class.
        /// </summary>
        public ScaleAction() { }

        /// <summary>
        /// Initializes a new instance of the ScaleAction class.
        /// </summary>
        /// <param name="direction">the scale direction. Whether the scaling
        /// action increases or decreases the number of instances. Possible
        /// values include: 'None', 'Increase', 'Decrease'</param>
        /// <param name="cooldown">the amount of time to wait since the last
        /// scaling action before this action occurs. It must be between 1
        /// week and 1 minute.</param>
        /// <param name="value">the number of instances that are involved in
        /// the scaling action. This value must be 1 or greater. The default
        /// value is 1.</param>
        public ScaleAction(ScaleDirection direction, System.TimeSpan cooldown, string value = default(string))
        {
            Direction = direction;
            Value = value;
            Cooldown = cooldown;
        }
        /// <summary>
        /// Static constructor for ScaleAction class.
        /// </summary>
        static ScaleAction()
        {
            Type = "ChangeCount";
        }

        /// <summary>
        /// Gets or sets the scale direction. Whether the scaling action
        /// increases or decreases the number of instances. Possible values
        /// include: 'None', 'Increase', 'Decrease'
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "direction")]
        public ScaleDirection Direction { get; set; }

        /// <summary>
        /// Gets or sets the number of instances that are involved in the
        /// scaling action. This value must be 1 or greater. The default
        /// value is 1.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "value")]
        public string Value { get; set; }

        /// <summary>
        /// Gets or sets the amount of time to wait since the last scaling
        /// action before this action occurs. It must be between 1 week and 1
        /// minute.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "cooldown")]
        public System.TimeSpan Cooldown { get; set; }

        /// <summary>
        /// the type of action that should occur, this must be set to
        /// ChangeCount.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "type")]
        public static string Type { get; private set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
        }
    }
}
