// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Insights.Models
{
    using System.Linq;

    /// <summary>
    /// A specific date-time for the profile. This element is not used if the
    /// Recurrence element is used.
    /// </summary>
    public partial class TimeWindow
    {
        /// <summary>
        /// Initializes a new instance of the TimeWindow class.
        /// </summary>
        public TimeWindow() { }

        /// <summary>
        /// Initializes a new instance of the TimeWindow class.
        /// </summary>
        /// <param name="start">the start time for the profile in ISO 8601
        /// format.</param>
        /// <param name="end">the end time for the profile in ISO 8601
        /// format.</param>
        /// <param name="timeZone">the time zone of the start and end times
        /// for the profile. See examples of valid timezone ids over here:
        /// https://msdn.microsoft.com/en-us/library/azure/dn931928.aspx</param>
        public TimeWindow(System.DateTime start, System.DateTime end, string timeZone = default(string))
        {
            TimeZone = timeZone;
            Start = start;
            End = end;
        }

        /// <summary>
        /// Gets or sets the time zone of the start and end times for the
        /// profile. See examples of valid timezone ids over here:
        /// https://msdn.microsoft.com/en-us/library/azure/dn931928.aspx
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "timeZone")]
        public string TimeZone { get; set; }

        /// <summary>
        /// Gets or sets the start time for the profile in ISO 8601 format.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "start")]
        public System.DateTime Start { get; set; }

        /// <summary>
        /// Gets or sets the end time for the profile in ISO 8601 format.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "end")]
        public System.DateTime End { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            //Nothing to validate
        }
    }
}
