// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.IotHub.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// The Feedback Queue properties.
    /// </summary>
    public partial class FeedbackProperties
    {
        /// <summary>
        /// Initializes a new instance of the FeedbackProperties class.
        /// </summary>
        public FeedbackProperties() { }

        /// <summary>
        /// Initializes a new instance of the FeedbackProperties class.
        /// </summary>
        public FeedbackProperties(TimeSpan? lockDurationAsIso8601 = default(TimeSpan?), TimeSpan? ttlAsIso8601 = default(TimeSpan?), int? maxDeliveryCount = default(int?))
        {
            LockDurationAsIso8601 = lockDurationAsIso8601;
            TtlAsIso8601 = ttlAsIso8601;
            MaxDeliveryCount = maxDeliveryCount;
        }

        /// <summary>
        /// The lock duration for the feedback queue. Range: 5 Sec (PT5S) - 5
        /// Min (PT5M).
        /// </summary>
        [JsonProperty(PropertyName = "lockDurationAsIso8601")]
        public TimeSpan? LockDurationAsIso8601 { get; set; }

        /// <summary>
        /// The time to live for the feedback queue. Range: 1 Min (PT1M) - 2
        /// Days (P2D).
        /// </summary>
        [JsonProperty(PropertyName = "ttlAsIso8601")]
        public TimeSpan? TtlAsIso8601 { get; set; }

        /// <summary>
        /// The max delivery count. Range : 1-100.
        /// </summary>
        [JsonProperty(PropertyName = "maxDeliveryCount")]
        public int? MaxDeliveryCount { get; set; }

        /// <summary>
        /// Validate the object. Throws ValidationException if validation fails.
        /// </summary>
        public virtual void Validate()
        {
            if (this.MaxDeliveryCount > 100)
            {
                throw new ValidationException(ValidationRules.InclusiveMaximum, "MaxDeliveryCount", 100);
            }
            if (this.MaxDeliveryCount < 1)
            {
                throw new ValidationException(ValidationRules.InclusiveMinimum, "MaxDeliveryCount", 1);
            }
        }
    }
}
