// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.IotHub.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// The description of the IotHub.
    /// </summary>
    public partial class IotHubDescription : Resource
    {
        /// <summary>
        /// Initializes a new instance of the IotHubDescription class.
        /// </summary>
        public IotHubDescription() { }

        /// <summary>
        /// Initializes a new instance of the IotHubDescription class.
        /// </summary>
        public IotHubDescription(string id = default(string), string name = default(string), string type = default(string), string location = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), string subscriptionid = default(string), string resourcegroup = default(string), string etag = default(string), IotHubProperties properties = default(IotHubProperties), IotHubSkuInfo sku = default(IotHubSkuInfo))
            : base(id, name, type, location, tags)
        {
            Subscriptionid = subscriptionid;
            Resourcegroup = resourcegroup;
            Etag = etag;
            Properties = properties;
            Sku = sku;
        }

        /// <summary>
        /// The subscription identifier.
        /// </summary>
        [JsonProperty(PropertyName = "subscriptionid")]
        public string Subscriptionid { get; set; }

        /// <summary>
        /// The resource group name uniquely identifies the resource group
        /// within the user subscriptionId.
        /// </summary>
        [JsonProperty(PropertyName = "resourcegroup")]
        public string Resourcegroup { get; set; }

        /// <summary>
        /// The Etag field is *not* required. If it is provided in the
        /// response body, it must also be provided as a header per the
        /// normal ETag convention.
        /// </summary>
        [JsonProperty(PropertyName = "etag")]
        public string Etag { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "properties")]
        public IotHubProperties Properties { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "sku")]
        public IotHubSkuInfo Sku { get; set; }

        /// <summary>
        /// Validate the object. Throws ValidationException if validation fails.
        /// </summary>
        public override void Validate()
        {
            base.Validate();
            if (this.Properties != null)
            {
                this.Properties.Validate();
            }
        }
    }
}
