// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Logic.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    public partial class AS2ProtocolSettings
    {
        /// <summary>
        /// Initializes a new instance of the AS2ProtocolSettings class.
        /// </summary>
        public AS2ProtocolSettings() { }

        /// <summary>
        /// Initializes a new instance of the AS2ProtocolSettings class.
        /// </summary>
        public AS2ProtocolSettings(AS2MessageConnectionSettings messageConnectionSettings = default(AS2MessageConnectionSettings), AS2AcknowledgementConnectionSettings acknowledgementConnectionSettings = default(AS2AcknowledgementConnectionSettings), AS2MdnSettings mdnSettings = default(AS2MdnSettings), AS2SecuritySettings securitySettings = default(AS2SecuritySettings), AS2ValidationSettings validationSettings = default(AS2ValidationSettings), AS2EnvelopeSettings envelopeSettings = default(AS2EnvelopeSettings), AS2ErrorSettings errorSettings = default(AS2ErrorSettings))
        {
            MessageConnectionSettings = messageConnectionSettings;
            AcknowledgementConnectionSettings = acknowledgementConnectionSettings;
            MdnSettings = mdnSettings;
            SecuritySettings = securitySettings;
            ValidationSettings = validationSettings;
            EnvelopeSettings = envelopeSettings;
            ErrorSettings = errorSettings;
        }

        /// <summary>
        /// Gets or sets the message connection settings.
        /// </summary>
        [JsonProperty(PropertyName = "messageConnectionSettings")]
        public AS2MessageConnectionSettings MessageConnectionSettings { get; set; }

        /// <summary>
        /// Gets or sets the acknowledgement connection settings.
        /// </summary>
        [JsonProperty(PropertyName = "acknowledgementConnectionSettings")]
        public AS2AcknowledgementConnectionSettings AcknowledgementConnectionSettings { get; set; }

        /// <summary>
        /// Gets or sets the MDN settings.
        /// </summary>
        [JsonProperty(PropertyName = "mdnSettings")]
        public AS2MdnSettings MdnSettings { get; set; }

        /// <summary>
        /// Gets or sets the security settings.
        /// </summary>
        [JsonProperty(PropertyName = "securitySettings")]
        public AS2SecuritySettings SecuritySettings { get; set; }

        /// <summary>
        /// Gets or sets the validation settings.
        /// </summary>
        [JsonProperty(PropertyName = "validationSettings")]
        public AS2ValidationSettings ValidationSettings { get; set; }

        /// <summary>
        /// Gets or sets the envelope settings.
        /// </summary>
        [JsonProperty(PropertyName = "envelopeSettings")]
        public AS2EnvelopeSettings EnvelopeSettings { get; set; }

        /// <summary>
        /// Gets or sets the error settings.
        /// </summary>
        [JsonProperty(PropertyName = "errorSettings")]
        public AS2ErrorSettings ErrorSettings { get; set; }

    }
}
