// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Logic.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    public partial class KeyVaultKeyReference
    {
        /// <summary>
        /// Initializes a new instance of the KeyVaultKeyReference class.
        /// </summary>
        public KeyVaultKeyReference() { }

        /// <summary>
        /// Initializes a new instance of the KeyVaultKeyReference class.
        /// </summary>
        public KeyVaultKeyReference(KeyVaultKeyReferenceKeyVault keyVault = default(KeyVaultKeyReferenceKeyVault), string keyName = default(string), string keyVersion = default(string))
        {
            KeyVault = keyVault;
            KeyName = keyName;
            KeyVersion = keyVersion;
        }

        /// <summary>
        /// Gets or sets the key vault reference.
        /// </summary>
        [JsonProperty(PropertyName = "keyVault")]
        public KeyVaultKeyReferenceKeyVault KeyVault { get; set; }

        /// <summary>
        /// Gets or sets the private key name in key vault.
        /// </summary>
        [JsonProperty(PropertyName = "keyName")]
        public string KeyName { get; set; }

        /// <summary>
        /// Gets or sets the private key version in key vault.
        /// </summary>
        [JsonProperty(PropertyName = "keyVersion")]
        public string KeyVersion { get; set; }

    }
}
