// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.MachineLearning.WebServices.Models
{
    using System.Linq;

    /// <summary>
    /// Sample input data for the service's input(s).
    /// </summary>
    public partial class ExampleRequest
    {
        /// <summary>
        /// Initializes a new instance of the ExampleRequest class.
        /// </summary>
        public ExampleRequest() { }

        /// <summary>
        /// Initializes a new instance of the ExampleRequest class.
        /// </summary>
        /// <param name="inputs">Sample input data for the web service's
        /// input(s) given as an input name to sample input values matrix
        /// map.</param>
        /// <param name="globalParameters">Sample input data for the web
        /// service's global parameters</param>
        public ExampleRequest(System.Collections.Generic.IDictionary<string, System.Collections.Generic.IList<System.Collections.Generic.IList<object>>> inputs = default(System.Collections.Generic.IDictionary<string, System.Collections.Generic.IList<System.Collections.Generic.IList<object>>>), System.Collections.Generic.IDictionary<string, object> globalParameters = default(System.Collections.Generic.IDictionary<string, object>))
        {
            Inputs = inputs;
            GlobalParameters = globalParameters;
        }

        /// <summary>
        /// Gets or sets sample input data for the web service's input(s)
        /// given as an input name to sample input values matrix map.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "inputs")]
        public System.Collections.Generic.IDictionary<string, System.Collections.Generic.IList<System.Collections.Generic.IList<object>>> Inputs { get; set; }

        /// <summary>
        /// Gets or sets sample input data for the web service's global
        /// parameters
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "globalParameters")]
        public System.Collections.Generic.IDictionary<string, object> GlobalParameters { get; set; }

    }
}
