// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.MachineLearning.WebServices.Models
{
    using System.Linq;

    /// <summary>
    /// Specifies a node in the web service graph. The node can either be an
    /// input, output or asset node, so only one of the corresponding id
    /// properties is populated at any given time.
    /// </summary>
    public partial class GraphNode
    {
        /// <summary>
        /// Initializes a new instance of the GraphNode class.
        /// </summary>
        public GraphNode() { }

        /// <summary>
        /// Initializes a new instance of the GraphNode class.
        /// </summary>
        /// <param name="assetId">The id of the asset represented by this
        /// node.</param>
        /// <param name="inputId">The id of the input element represented by
        /// this node.</param>
        /// <param name="outputId">The id of the output element represented by
        /// this node.</param>
        /// <param name="parameters">If applicable, parameters of the node.
        /// Global graph parameters map into these, with values set at
        /// runtime.</param>
        public GraphNode(string assetId = default(string), string inputId = default(string), string outputId = default(string), System.Collections.Generic.IDictionary<string, string> parameters = default(System.Collections.Generic.IDictionary<string, string>))
        {
            AssetId = assetId;
            InputId = inputId;
            OutputId = outputId;
            Parameters = parameters;
        }

        /// <summary>
        /// Gets or sets the id of the asset represented by this node.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "assetId")]
        public string AssetId { get; set; }

        /// <summary>
        /// Gets or sets the id of the input element represented by this node.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "inputId")]
        public string InputId { get; set; }

        /// <summary>
        /// Gets or sets the id of the output element represented by this node.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "outputId")]
        public string OutputId { get; set; }

        /// <summary>
        /// Gets or sets if applicable, parameters of the node. Global graph
        /// parameters map into these, with values set at runtime.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "parameters")]
        public System.Collections.Generic.IDictionary<string, string> Parameters { get; set; }

    }
}
