// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.ResourceManager.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// The policy definition.
    /// </summary>
    public partial class PolicyDefinition : IResource
    {
        /// <summary>
        /// Initializes a new instance of the PolicyDefinition class.
        /// </summary>
        public PolicyDefinition() { }

        /// <summary>
        /// Initializes a new instance of the PolicyDefinition class.
        /// </summary>
        public PolicyDefinition(string id = default(string), string name = default(string), string policyType = default(string), string displayName = default(string), string description = default(string), object policyRule = default(object))
        {
            Id = id;
            Name = name;
            PolicyType = policyType;
            DisplayName = displayName;
            Description = description;
            PolicyRule = policyRule;
        }

        /// <summary>
        /// Gets or sets the Id of the policy definition.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets the name of the policy definition.
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets policy definition policy type. Possible values for
        /// this property include: 'NotSpecified', 'BuiltIn', 'Custom'.
        /// </summary>
        [JsonProperty(PropertyName = "properties.policyType")]
        public string PolicyType { get; set; }

        /// <summary>
        /// Gets or sets the policy definition display name.
        /// </summary>
        [JsonProperty(PropertyName = "properties.displayName")]
        public string DisplayName { get; set; }

        /// <summary>
        /// Gets or sets the policy definition description.
        /// </summary>
        [JsonProperty(PropertyName = "properties.description")]
        public string Description { get; set; }

        /// <summary>
        /// Gets or sets the policy rule.
        /// </summary>
        [JsonProperty(PropertyName = "properties.policyRule")]
        public object PolicyRule { get; set; }

    }
}
