// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.WebSites.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Description of the App Service Plan scale options
    /// </summary>
    public partial class SkuCapacity
    {
        /// <summary>
        /// Initializes a new instance of the SkuCapacity class.
        /// </summary>
        public SkuCapacity() { }

        /// <summary>
        /// Initializes a new instance of the SkuCapacity class.
        /// </summary>
        public SkuCapacity(int? minimum = default(int?), int? maximum = default(int?), int? defaultProperty = default(int?), string scaleType = default(string))
        {
            Minimum = minimum;
            Maximum = maximum;
            DefaultProperty = defaultProperty;
            ScaleType = scaleType;
        }

        /// <summary>
        /// Minimum number of Workers for this App Service Plan SKU
        /// </summary>
        [JsonProperty(PropertyName = "minimum")]
        public int? Minimum { get; set; }

        /// <summary>
        /// Maximum number of Workers for this App Service Plan SKU
        /// </summary>
        [JsonProperty(PropertyName = "maximum")]
        public int? Maximum { get; set; }

        /// <summary>
        /// Default number of Workers for this App Service Plan SKU
        /// </summary>
        [JsonProperty(PropertyName = "default")]
        public int? DefaultProperty { get; set; }

        /// <summary>
        /// Available scale configurations for an App Service Plan
        /// </summary>
        [JsonProperty(PropertyName = "scaleType")]
        public string ScaleType { get; set; }

    }
}
