// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.WebSites.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Class containing names for connection strings and application settings
    /// to be marked as sticky to the slot
    /// and not moved during swap operation
    /// This is valid for all deployment slots under the site
    /// </summary>
    public partial class SlotConfigNames
    {
        /// <summary>
        /// Initializes a new instance of the SlotConfigNames class.
        /// </summary>
        public SlotConfigNames() { }

        /// <summary>
        /// Initializes a new instance of the SlotConfigNames class.
        /// </summary>
        public SlotConfigNames(IList<string> connectionStringNames = default(IList<string>), IList<string> appSettingNames = default(IList<string>))
        {
            ConnectionStringNames = connectionStringNames;
            AppSettingNames = appSettingNames;
        }

        /// <summary>
        /// List of connection string names
        /// </summary>
        [JsonProperty(PropertyName = "connectionStringNames")]
        public IList<string> ConnectionStringNames { get; set; }

        /// <summary>
        /// List of application settings names
        /// </summary>
        [JsonProperty(PropertyName = "appSettingNames")]
        public IList<string> AppSettingNames { get; set; }

    }
}
