// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Search.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Provides parameter values to a freshness scoring function.
    /// </summary>
    public partial class FreshnessScoringParameters
    {
        /// <summary>
        /// Initializes a new instance of the FreshnessScoringParameters class.
        /// </summary>
        public FreshnessScoringParameters() { }

        /// <summary>
        /// Initializes a new instance of the FreshnessScoringParameters class.
        /// </summary>
        public FreshnessScoringParameters(TimeSpan boostingDuration)
        {
            BoostingDuration = boostingDuration;
        }

        /// <summary>
        /// Gets or sets the expiration period after which boosting will stop
        /// for a particular document.
        /// </summary>
        [JsonProperty(PropertyName = "boostingDuration")]
        public TimeSpan BoostingDuration { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            //Nothing to validate
        }
    }
}
